﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.IO;
using DS.Web.AuthCode;
using System.Web.SessionState;
using System.Drawing;
using Microsoft.Practices.Unity;

namespace DS.Web.AuthCode.Example
{
    /// <summary>
    /// AuthCode 的摘要说明
    /// </summary>
    public class AuthCode : IHttpHandler, IRequiresSessionState
    {
        public void ProcessRequest(HttpContext context)
        {
            string id = context.Request["id"];
            AuthCodeManager am = new AuthCodeManager(new AuthCodeBuilder());
            context.Response.ContentType = "image/jpeg";
            context.Response.Clear();
            context.Response.BinaryWrite(am.Create(id).ToArray());
        }

        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }

    public class AuthCodeBuilder : IAuthCodeBuilder
    {
        private string code;
        public string CreateAuthCode()
        {
            code = new Random().Next(1000,9999).ToString();
            return code;
        }

        public string CreateAuthCode(string codeString)
        {
            code = codeString;
            return code;
        }

        public MemoryStream GetAuthCodeStream()
        {
            var checkCode = code;
            if (checkCode == null || checkCode.Trim() == String.Empty)
                return null;

            System.Drawing.Bitmap image = new System.Drawing.Bitmap((int)Math.Ceiling((checkCode.Length * 12.5)), 22);
            Graphics g = Graphics.FromImage(image);

            try
            {
                //生成随机生成器
                Random random = new Random();

                //清空图片背景色
                g.Clear(Color.White);

                //画图片的背景噪音线
                for (int i = 0; i < 25; i++)
                {
                    int x1 = random.Next(image.Width);
                    int x2 = random.Next(image.Width);
                    int y1 = random.Next(image.Height);
                    int y2 = random.Next(image.Height);

                    g.DrawLine(new Pen(Color.Silver), x1, y1, x2, y2);
                }

                Font font = new System.Drawing.Font("Arial", 12, (System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic));
                System.Drawing.Drawing2D.LinearGradientBrush brush = new System.Drawing.Drawing2D.LinearGradientBrush(new Rectangle(0, 0, image.Width, image.Height), Color.Blue, Color.DarkRed, 1.2f, true);
                g.DrawString(checkCode, font, brush, 2, 2);

                //画图片的前景噪音点
                for (int i = 0; i < 100; i++)
                {
                    int x = random.Next(image.Width);
                    int y = random.Next(image.Height);

                    image.SetPixel(x, y, Color.FromArgb(random.Next()));
                }

                //画图片的边框线
                g.DrawRectangle(new Pen(Color.Silver), 0, 0, image.Width - 1, image.Height - 1);

                System.IO.MemoryStream ms = new System.IO.MemoryStream();
                image.Save(ms, System.Drawing.Imaging.ImageFormat.Gif);
                return ms;
            }
            finally
            {
                g.Dispose();
                image.Dispose();
            } 
        }
    }
}