﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.IO;
using System.Drawing;

namespace DS.Web.AuthCode.MVCExample.Controllers
{
    [HandleError]
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            Bind();
            ViewData["Message"] = "欢迎使用 ASP.NET MVC!";

            return View();
        }

        [HttpPost]
        public ActionResult Index(string sessionID,string code)
        {
            Bind();
            AuthCodeManager am = new AuthCodeManager(new AuthCodeBuilder());
            if (am.Authorize(sessionID, code))
            {
                Response.Write("<script>alert('成功！');</script>");
            }
            else
            {
                Response.Write("<script>alert('失败！');</script>");
            }
            return View();
        }

        public ActionResult AuthCode(string id)
        {
            AuthCodeManager am = new AuthCodeManager(new AuthCodeBuilder());
            return File(am.Create(id).ToArray(), "image/jpeg");
        }

        protected void Bind()
        {
            var ticks = DateTime.Now.Ticks.ToString();
            ViewData["imageURL"] = "home/authcode/" + ticks;
            ViewData["sessionID"] = ticks;
        }
    }

    public class AuthCodeBuilder : IAuthCodeBuilder
    {
        private string code;
        public string CreateAuthCode()
        {
            code = new Random().Next(1000, 9999).ToString();
            return code;
        }

        public string CreateAuthCode(string codeString)
        {
            code = codeString;
            return code;
        }

        public MemoryStream GetAuthCodeStream()
        {
            var checkCode = code;
            if (checkCode == null || checkCode.Trim() == String.Empty)
                return null;

            System.Drawing.Bitmap image = new System.Drawing.Bitmap((int)Math.Ceiling((checkCode.Length * 12.5)), 22);
            Graphics g = Graphics.FromImage(image);

            try
            {
                //生成随机生成器
                Random random = new Random();

                //清空图片背景色
                g.Clear(Color.White);

                //画图片的背景噪音线
                for (int i = 0; i < 25; i++)
                {
                    int x1 = random.Next(image.Width);
                    int x2 = random.Next(image.Width);
                    int y1 = random.Next(image.Height);
                    int y2 = random.Next(image.Height);

                    g.DrawLine(new Pen(Color.Silver), x1, y1, x2, y2);
                }

                Font font = new System.Drawing.Font("Arial", 12, (System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic));
                System.Drawing.Drawing2D.LinearGradientBrush brush = new System.Drawing.Drawing2D.LinearGradientBrush(new Rectangle(0, 0, image.Width, image.Height), Color.Blue, Color.DarkRed, 1.2f, true);
                g.DrawString(checkCode, font, brush, 2, 2);

                //画图片的前景噪音点
                for (int i = 0; i < 100; i++)
                {
                    int x = random.Next(image.Width);
                    int y = random.Next(image.Height);

                    image.SetPixel(x, y, Color.FromArgb(random.Next()));
                }

                //画图片的边框线
                g.DrawRectangle(new Pen(Color.Silver), 0, 0, image.Width - 1, image.Height - 1);

                System.IO.MemoryStream ms = new System.IO.MemoryStream();
                image.Save(ms, System.Drawing.Imaging.ImageFormat.Gif);
                return ms;
            }
            finally
            {
                g.Dispose();
                image.Dispose();
            }
        }
    }
}
